#ifndef __MACRO_H__
#define __MACRO_H__
#include <iostream>
#include <string>
#include <vector>
using namespace std;

extern bool                   gv_matching_symbol_flag;

extern int                    gv_align_alphabet_size;
extern int                    gv_seed_alphabet_size;

extern vector<int>            gv_signature;
extern bool                   gv_signature_flag;

extern vector<double>         gv_bsel_weight;

extern double                 gv_bsel_minprob,gv_bsel_maxprob;
extern int                    gv_minspan,   gv_maxspan;
extern double                 gv_minweight, gv_maxweight;
extern bool                   gv_weight_interval;
extern bool                   gv_vectorized_flag;
extern char *                 gv_bsymbols_array;
extern bool                   gv_bsymbols_flag;

/*
 * (I) Usefull functions
 */

#define ASSERT(ptr)                                                   \
  if (!(ptr)){                                                        \
    cerr << "*ERROR : memory allocation failed on" << #ptr <<   endl; \
    exit(-1);                                                         \
  }

#define ERROR(message1,message2) {                              \
  cerr << "*ERROR : " << message1 << " : " << message2 << endl; \
  exit(-1);                                                     \
}

#define WARNING(message1,message2) {                              \
  cerr << "*WARNING : " << message1 << " : " << message2 << endl; \
}

#define OUTSTREAM (gv_ofstream.is_open()?gv_ofstream:cout)
#define MAX(a,b) ((a)>(b)?(a):(b)) 
#define MAX3(a,b,c) MAX((a),MAX((b),(c)))
#define MIN(a,b) ((a)<(b)?(a):(b))
#define MIN3(a,b,c) MIN((a),MIN((b),(c)))
#define ABS(a) ((a)>=0?(a):(-a))

#define PINFINITY   (0x7fffffff)  
#define NINFINITY   (0x80000000)

#define BINARY(u,r,o)                             \
  for (int _i__ = 1; _i__ <  (1<<r) ;_i__ <<=1){  \
     if (_i__&u)                                  \
        o << "1";                                 \
     else                                         \
        o << "0";                                 \
  }

int power(int x, int n);
double power(double x, int n);

/*
 *  (II) Constants
 */

#define FALSE      0
#define TRUE       1
#define KILO      (1024)
#define MEGA      (KILO*KILO)
#define GIGA      (MEGA*KILO)


/*
 *  (III) specific definitions 
 */

#define XSET         (unsigned int)
#define XSETBITSIZE  (sizeof(XSET)*8)

//#define ASSERTB
#define USEQUEUE
//#define BUILD
#define USEMAP


#endif  

